lfs = require 'lfs'
import dir, rmdir from lfs
lfs_mkdir = lfs.mkdir
make_link = lfs.link
attributes = lfs.attributes
exist = => nil ~= attributes @
cd = lfs.chdir
pwd = lfs.currentdir
link_exist = lfs.symlinkattributes
import open, popen from io
import find, sub from string
import concat from table
import remove from os
json = require 'cjson'
json_decode = json.decode
json_encode = json.encode
moonscript_compile = require 'moonscript.compile'
moonscript_parse_string = require('moonscript.parse').string
moonscript_compile_tree = moonscript_compile.tree
moonscript_format_error = moonscript_compile.format_error
https = require "ssl.https"

import pick_installed_rock from require "luarocks.search"
import match_constraints, parse_version
	parse_constraints, parse_dep, fulfill_dependencies from require 'luarocks.deps'
import rocks_servers, rocks_trees from require 'luarocks.cfg'
require('luarocks.path').use_tree rocks_trees[#rocks_trees]

local gits_path, project_path, gits_old

gits = {}
gits_new = {}
rocks = {}
installed_rocks = {}

err = (msg) ->
	print '\27[1;91mError: \27[0;0m' .. msg

-- string

split = (s) =>
	pos, i, res = 1, 1, {}
	while true
		new = find @, s, pos
		if new == nil
			res[i] = sub @, pos
			break
		else
			res[i] = sub @, pos, new - 1
			i += 1
			pos = new + 1
	res

-- table

slice = (arr, f, t) ->
	len = #arr
	if t == nil
		t = len
	elseif t < 0
		t = len + t
	res = {}
	i = 0
	for n = f, t
		i += 1
		res[i] = arr[n]
	res 

-- file

read = (path) ->
	f = open path, 'r'
	return false if f == nil
	ret = f\read '*a'
	f\close!
	ret

write = (path, content) ->
	f = open path, 'w'
	f\write content
	f\close!

moon_to_lua = (source) ->
	tree, err = moonscript_parse_string source
	error err unless tree
	code, ltable, pos = moonscript_compile_tree tree, options
	error moonscript_format_error ltable, pos, source unless code
	code


-- dir

mkdir = (p) ->
	lfs_mkdir p if nil == exist p

mkdir_r = (path) ->
	c = 0
	create = {}
	s = split path, '/'
	l = #s
	while l > 0
		l -= 1
		break if nil ~= exist path
		c += 1
		create[c] = path
		s = slice s, 1, -1
		path = concat s, '/'
	for i = c, 1, -1
		lfs_mkdir create[i]

isdir = => attributes(@).mode == 'directory'

rmrf = (path) ->
	for rel in dir path
		if rel ~= '.' and rel ~= '..'
			full = path .. '/' .. rel
			if isdir full then rmrf full
			else remove full
	rmdir path

-- install

get_https = (url) ->
	response_body = {}
	res, code, response_headers = https.request :url, method: "GET", sink: ltn12.sink.table response_body
	concat response_body, ''

get_sha = (url) ->
	json_decode(get_https "https://api.github.com/repos/" .. url .. "/commits/master").commit.tree.sha

source = (url) ->
	if rocks_servers[2] == nil then rocks_servers[1], rocks_servers[2] = url, rocks_servers[1]
	else rocks_servers[1] = url
rock = (name, version) ->
	ex, current = pick_installed_rock name
	if ex == nil or version ~= nil and false == match_constraints parse_version(current),
			parse_constraints version
		rocks[name] = version or true
git = (url) -> gits[url] = true

write_required = (full) ->
	required_by_path = full .. '/.required_by'
	if exist required_by_path
		file = open required_by_path, 'r'
		finded = false
		while true
			line = file\read!
			break if line == nil
			if line == project_path
				finded = true
				break
		file\close!
		if finded == false
			file = open required_by_path, 'a'
			file\write project_path .. '\n'
			file\close!
	else
		write required_by_path, project_path

readlink = (link_path) ->
	cd link_path
	path = pwd!
	cd project_path
	path

sha_from_link = (link_path) ->
	s = split readlink(link_path), '/'
	s[#s]

usin = (name) -> print '\27[1;37mUsing \27[0;0m' .. name
updating = (name) -> print '\27[1;35mUpdating \27[0;0m' .. name
installing = (name) -> print '\27[1;32mInstalling \27[0;0m' .. name

install_git = (url, name, link_path, sha) ->
	link_path = 'lib/' .. name
	local full
	if sha == nil and exist link_path
		usin name
		full = readlink link_path
		s = split full, '/'
		sha = s[#s]
	else
		sha = get_sha url if sha == nil
		path = gits_path .. '/' .. name
		full = path .. '/' .. sha
		if exist full
			usin name
		else
			if exist path
				updating name
			else
				installing name
			mkdir_r full
			popen('git clone --depth=1 -q https://github.com/' .. url .. ' ' .. full)\close!
		make_link full, link_path, true
	write_required full
	sha

local install

maybe_install_git = (url, update) ->
	name = split(url, '/')[2]
	link_path = 'lib/' .. name
	sha = gits_old[name]
	sha = gits_new[name] if sha == nil
	if exist link_path
		sha = sha_from_link link_path if sha == nil
	else
		sha = nil
	if sha == nil
		sha = install_git url, name, link_path
	elseif update
		latest = get_sha url
		if latest == sha
			usin name
		else
			remove 'lib/' .. name
			sha = install_git url, name, link_path, latest
	else
		usin name
	gits_new[name] = sha
	rockfile_path = link_path .. '/Rockfile'
	install name, rockfile_path, update if exist rockfile_path

install = (project_name, rockfile_path, update) ->
	gits_were, gits, rocks_were, rocks = gits, {}, rocks, {}
	rocks_servers[1], rocks_servers[2] = rocks_servers[2], nil if rocks_servers[2] ~= nil

	setfenv(loadstring(moon_to_lua read rockfile_path), :source, :rock, :git)!

	maybe_install_git url, update for url in pairs gits

	i = 0
	rocks_array = {}
	for name, version in pairs rocks
		if installed_rocks[name] == nil
			i += 1
			rocks_array[i] = parse_dep version == true and name or name .. ' ' .. version
			installed_rocks[name] = true

	assert fulfill_dependencies {name: project_name, version: '\b', dependencies: rocks_array}, 'one'

	gits, rocks = gits_were, rocks_were


-- remove

remove_sha = (name, sha) ->
	full = gits_path .. '/' .. name .. '/' .. sha
	required_by_path = full .. '/.required_by'
	if exist required_by_path
		file = open required_by_path, 'r'
		lines = ''
		while true
			line = file\read!
			break if line == nil
			lines ..= line .. '\n' if line ~= project_path
		file\close!
		if #lines > 0
			return write required_by_path, lines
	print '\27[1;30mRemoving\27[0;0m ' .. name .. ' with sha ' .. sha
	rmrf full

remove_git_unless_required = (name) ->
	full = gits_path .. '/' .. name
	required = false
	for sha in dir full
		unless sha == '.' or sha == '..'
			content = read full .. '/' .. sha .. '/.required_by'
			if content ~= false and 0 ~= #content
				required = true
				break
	if required == false
		print '\27[1;30mRemoving\27[0;0m unrequired ' .. name
		rmrf full

check_rockfile = ->
	if nil == exist 'Rockfile'
		err 'could not find Rockfile'
	else true

after_install = ->
	for name, sha in pairs gits_old
		new = gits_new[name]
		if new ~= sha
			remove_sha name, sha
			if new == nil
				remove_git_unless_required name
				remove 'lib/' .. name
	lock = 'gits = {'
	name, sha = next gits_new
	if name ~= nil
		lock ..= '\n\t["' .. name .. '"] = "' .. sha .. '"'
		while true
			name, sha = next gits_new, name
			break if name == nil
			lock ..= ',\n\t["' .. name .. '"] = "' .. sha .. '"'
	write 'Rockfile.lock', lock .. '\n}'

get_project_name = ->
	s = split project_path, '/'
	s[#s]

actions =
	install: ->
		if check_rockfile! == true
			install get_project_name!, 'Rockfile'
			after_install!
	update: ->
		if check_rockfile! == true
			install get_project_name!, 'Rockfile', true
			after_install!

(args) ->
	command = args[1]
	command = 'install' if command == nil
	action = actions[command]
	if action == nil
		err 'could not find command "' .. command .. '"'
	else
		lua_config = os.getenv 'LUA_CONFIG'
		home_path = os.getenv 'HOME'
		lua_config = home_path .. '/.lua/config' if lua_config == nil
		config_content = read lua_config .. '/lundler.lua'
		config = {}
		if config_content ~= false
			setfenv(loadstring(config_content), config)!
		import gits_path from config
		gits_path = 'gits' if gits_path == nil
		gits_path = home_path .. '/.lua/' .. gits_path
		mkdir_r gits_path
		project_path = pwd!
		lock = read 'Rockfile.lock'
		if lock ~= false
			fenv = {}
			setfenv(loadstring(lock), fenv)!
			gits_old = fenv.gits
		gits_old = {} if gits_old == nil
		action args